"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parse = void 0;
const types_1 = require("./types");
function parse(str) {
    // We don't use the reviver option in `JSON.parse(str, reviver)` because it doesn't support `undefined` values
    const value = JSON.parse(str);
    return modifier(value);
}
exports.parse = parse;
function modifier(value) {
    if (typeof value === 'string') {
        return reviver(value);
    }
    if (typeof value === 'object' && value !== null) {
        Object.entries(value).forEach(([key, val]) => {
            ;
            value[key] = modifier(val);
        });
    }
    return value;
}
function reviver(value) {
    for (const { match, deserialize } of types_1.types) {
        if (match(value)) {
            return deserialize(value, parse);
        }
    }
    return value;
}
